using BAP.Cap.Sqlsugar.Demo1.Entity;
using DotNetCore.CAP;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
using SqlSugar;
using System.Data;

namespace BAP.Cap.Sqlsugar.Demo1.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
        "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
    };

        private readonly ILogger<WeatherForecastController> _logger;

        private ICapPublisher _capBus;
        private SqlSugarScope _sqlSugarScope;
        public WeatherForecastController(ILogger<WeatherForecastController> logger, ICapPublisher capPublisher, SqlSugarScope sqlSugarScope)
        {
            _sqlSugarScope= sqlSugarScope;
            _logger = logger;
            _capBus = capPublisher;
        }

        [HttpGet,Route("TestPublish")]
        public async Task TestPublish()
        {
            await _capBus.PublishAsync("sample.rabbitmq.sqlserver", DateTime.Now);
        }

        [HttpGet,Route("~/adonet/transaction")]
        public IActionResult AdonetWithTransaction()
        {
            //_sqlSugarScope.ScopedContext.BeginTran
            //_sqlSugarScope.GetConnection(1)
            //_sqlSugarScope.ScopedContext.UseTran().
            //IDbConnection.
          
            using (var connection =(SqlConnection) _sqlSugarScope.Ado.Connection )
            {
                using (var transaction = connection.BeginTransaction(_capBus, false))
                {
                    if (connection.State != ConnectionState.Open)
                    {
                        connection.Open();
                    }
                    _sqlSugarScope.Ado.Transaction =transaction;
                    //_sqlSugarScope.Insertable<Num>(new Num()
                    //{
                    //    Id = 1,
                    //    Number1 = 2
                    //}).ExecuteCommand();


                    _capBus.Publish("sample.rabbitmq.sqlserver.transaction", "ִ");
                    transaction.Commit();
                }
            }
            return Ok();
        }



        [HttpGet(Name = "GetWeatherForecast")]
        public IEnumerable<WeatherForecast> Get()
        {
            return Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = Random.Shared.Next(-20, 55),
                Summary = Summaries[Random.Shared.Next(Summaries.Length)]
            })
            .ToArray();
        }
    }
}